package cn.efunbox.audio.controller;

import cn.efunbox.audio.entity.Channel;
import cn.efunbox.audio.service.ChannelService;
import cn.efunbox.audio.utils.ApiCode;
import cn.efunbox.audio.utils.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@RestController
@Slf4j
@RequestMapping(value = "/channel")
public class ChannelController {

    @Autowired
    ChannelService channelService;

    @RequestMapping(value = "/search" ,method = RequestMethod.POST)
    public void Search(HttpServletRequest request, HttpServletResponse response){
        String name = request.getParameter("name");
        String idChannel = request.getParameter("idChannel");
        List<Channel> list = null;
        if(idChannel!=null && idChannel.length()>0)
            list = channelService.SearchById(Long.valueOf(idChannel));
        else if(name!=null && name.length()>0)
            list = channelService.SearchByName(name);
        else
            list = channelService.SearchAll();

        HttpUtil.responseOkData(request, response, list);
        return;
    }

//    @RequestMapping(value = "/insert", method = RequestMethod.POST)
//    public void Insert(HttpServletRequest request, HttpServletResponse response){
//        String name = request.getParameter("name");
//        String idFather = request.getParameter("idFather");
//        if(name==null){
//            HttpUtil.responseApiCode(request, response, ApiCode.PARAMETER_ERROR);
//            return;
//        }
//        if(idFather==null || idFather.length()==0)
//            idFather = "0";
//
//        List<Channel> list = channelService.SearchByName(name);
//        if(list!=null && list.size()>0){
//            HttpUtil.responseApiCode(request, response, ApiCode.RECORD_EXIST);
//            return;
//        }
//        Channel channel = new Channel();
//        channel.setName(name);
//        channel.setIdFather(Long.valueOf(idFather));
//        channel = channelService.Insert(channel);
//        HttpUtil.responseOutWithJson(request, response, channel);
//        return;
//    }

    @RequestMapping(value = "/insert", method = RequestMethod.POST)
    public void Insert(HttpServletRequest request, HttpServletResponse response, @RequestBody Channel channel){
        List<Channel> list = channelService.SearchByName(channel.getName());
        if(list!=null && list.size()>0){
            HttpUtil.responseApiCode(request, response, ApiCode.RECORD_EXIST);
            return;
        }
        channel.setCreated(new Date());
        channel = channelService.Insert(channel);
        HttpUtil.responseOutWithJson(request, response, channel);
        return;
    }

    @RequestMapping(value = "/update", method = RequestMethod.POST)
    public void Update(HttpServletRequest request, HttpServletResponse response, @RequestBody Channel channel){
        List<Channel> list = channelService.SearchByName(channel.getName());
        if(list!=null && list.size()>0){
            HttpUtil.responseApiCode(request, response, ApiCode.RECORD_EXIST);
            return;
        }
        channel.setCreated(new Date());
        channel = channelService.Insert(channel);
        HttpUtil.responseOutWithJson(request, response, channel);
        return;
    }

}
